//
//  LeftPannelViewController.m
//  reader
//
//  Created by caiwengui on 13-9-30.
//  Copyright (c) 2013年 caiwengui. All rights reserved.
//

#import "LeftPannelViewController.h"
#import "Chapter.h"

@interface LeftPannelViewController ()

// table view
@property (nonatomic, weak) IBOutlet UITableView *myTableView;
@property (nonatomic, weak) IBOutlet UITableViewCell *cellMain;

// chapters
@property (nonatomic, strong) NSMutableArray *arrayOfChapters;

@end

@implementation LeftPannelViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    
	// Do any additional setup after loading the view.
    [self setupChapterArray];
}

// view appear
- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}


// view disappear
- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
}


- (void)setupChapterArray
{
    // define left navigation chapters
    NSArray *chapters = @[
    //TODO: fix errors
    //[Chapter itemWithTitle:@"Sleep Cat" withImage:[UIImage imageNamed:@"ID-100113060.jpg"] withCreator:@"chapter1"],
    //[Chapter itemWithTitle:@"Chapter 2" withImage:[UIImage imageNamed:@"ID-100113061.jpg"] withCreator:@"chapter2"]
    ];
    
    self.arrayOfChapters = [NSMutableArray arrayWithArray:chapters];
    [self.myTableView reloadData];
}


// datasource/delegate
- (NSInteger)numberOfSectionInTableView:(UITableView *)tableview;
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [_arrayOfChapters count];
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 54;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *cellMainNibID = @"cellMain";
    
    _cellMain = [tableView dequeueReusableCellWithIdentifier:cellMainNibID];
    
    if (_cellMain == nil) {
        [[NSBundle mainBundle] loadNibNamed:@"MainCellLeft" owner:self options:nil];
    }
    
    UIImageView *mainImage = (UIImageView *)[_cellMain viewWithTag:1];
    UILabel *imageTitle = (UILabel *)[_cellMain viewWithTag:2];
    UILabel *creator = (UILabel *)[_cellMain viewWithTag:3];
    
    if ([_arrayOfChapters count] > 0) {
        Chapter *currentRecord = [self.arrayOfChapters objectAtIndex:indexPath.row];
        
        mainImage.image = currentRecord.image;
        imageTitle.text = [NSString stringWithFormat:@"%@", currentRecord.title];
        creator.text = [NSString stringWithFormat:@"%@", currentRecord.creator];
    }
    
    return _cellMain;
}

- (void)tableView:(UITableView *)tableView didDeselectRowAtIndexPath:(NSIndexPath *)indexPath
{
    Chapter *currentRecord = [self.arrayOfChapters objectAtIndex:indexPath.row];
    
    [_delegate chapterSelected:currentRecord];
}



- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end