//
//  ViewController.m
//  reader
//
//  Created by caiwengui on 13-9-29.
//  Copyright (c) 2013年 caiwengui. All rights reserved.
//

#import "ViewController.h"
#import "LeftPannelViewController.h"
#import "MainViewController.h"

#define CENTER_TAG 1
#define LEFT_PANNEL_TAG 2

@interface ViewController ()
{
    CGFloat width;
    CGFloat height;
}

@property(nonatomic, strong) MainViewController *MainViewController;
@property(nonatomic, strong) LeftPannelViewController *leftPannelViewController;

@property(nonatomic, assign) BOOL showingLeftPannel;

@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    [self setupView];
    
    // get device height and Height
    /*
    CGRect rect = [[UIScreen mainScreen] bounds];
    CGSize size = rect.size;
    width = size.width;
    height = size.height;

    //TODO:  set width and height with device width and height
    leftView = [[UIWebView alloc] initWithFrame:CGRectMake(0, 0, 80, height)];
    [leftView setDelegate:self];
    [self.view addSubview:leftView];

    webView = [[UIWebView alloc] initWithFrame:CGRectMake(0, 0, width, height)];
    [webView setDelegate:self];
    //TODO: config the request url
    NSURLRequest *request = [NSURLRequest requestWithURL:[NSURL URLWithString:@"http://cwgis.github.io"]];

    // add self.view
    [self.view addSubview:webView];

    // load request url
    [webView loadRequest:request];
    */
}

// main view appear
- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}
- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

// main view disapper
- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
}
- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
}


- (void) setupView
{
    self.MainViewController = [[MainViewController alloc] initWithNibName:@"MainViewController" bundle: nil];
    self.MainViewController.view.tag = CENTER_TAG;
    self.MainViewController.delegate = _MainViewController;
    
    [self.view addSubview:self.MainViewController.view];
    [self addChildViewController:_MainViewController];
    [_MainViewController didMoveToParentViewController:self];
}

- (void) resetMainView
{
    
}

- (UIView *)getLeftView
{
    if (_leftPannelViewController == nil) {
        self.leftPannelViewController = [[LeftPannelViewController alloc] initWithNibName:@"LeftPannelViewController" bundle:nil];
        self.leftPannelViewController.view.tag = LEFT_PANNEL_TAG;
        self.leftPannelViewController.delegate = _MainViewController;

        [self.view addSubview:self.leftPannelViewController.view];
        [self addChildViewController:_leftPannelViewController];
        [_leftPannelViewController didMoveToParentViewController:self];
        
        _leftPannelViewController.view.frame = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
    }
    
    self.showingLeftPannel = YES;
    //[self showCenterViewWithShadow: YES withOffset: 2];
    
    UIView *view = self.leftPannelViewController.view;
    return view;
}

- (void) setupGestures
{
    
}

- (void) movePannel:(id)sender
{
    
}

- (void) movePannelRight
{
    
}

- (void) resetPannel
{
    
}


// start to load web page
- (void)webViewDidStartLoad:(UIWebView *)webView
{
    // add loading status
    UIView *view = [[UIView alloc] initWithFrame:CGRectMake(0, 0, width, height)];
    [view setTag:108];
    [view setBackgroundColor:[UIColor blackColor]];
    [view setAlpha:0.5];
    [self.view addSubview:view];

    activityIndicator = [[UIActivityIndicatorView alloc] initWithFrame:CGRectMake(0.0f, 0.0f, 32.0f, 32.0f)];
    [activityIndicator setCenter:view.center];
    [activityIndicator setActivityIndicatorViewStyle:UIActivityIndicatorViewStyleWhite];
    [view addSubview:activityIndicator];
    
    [activityIndicator startAnimating];

    NSLog(@"webView Start to Load");
}

// loaded web page finished
- (void)webViewDidFinishLoad:(UIWebView *)webView
{
    // remove loading status
    [activityIndicator stopAnimating];
    UIView *view = (UIView*)[self.view viewWithTag:108];
    [view removeFromSuperview];
    
    NSLog(@"webivew finish load");
}

// load web page occus error
- (void)webView:(UIWebView *)webView didFailLoadWithError:(NSError *)error
{
    // remove loading status
    [activityIndicator stopAnimating];
    UIView *view = (UIView*)[self.view viewWithTag:108];
    [view removeFromSuperview];

    NSLog(@"webview load error");
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
